<template>
	<div>
		<VueperSlides
			class="no-shadow"
			:autoplay="autoplaying"
			ref="Carousel"
			fixedHeight="30vh"
			:pause-on-hover="pauseOnHover"
			:dragging-distance="70"
			@previous="$refs.Carousel.pauseAutoplay()"
			@next="$refs.Carousel.pauseAutoplay()"
		>
			<VueperSlide v-for="(image, i) of images" :key="i" :image="image.url" @click.native="zoomSlide($refs.Carousel.currentSlide.image), $refs.Carousel.pauseAutoplay()"/>
		</VueperSlides>

		<Modal class="modal" v-if="modalImage" @close="hideSlide()">
			<img class="modal-image" :src="current"/>
		</Modal>
	</div>
</template>

<script lang="ts">
import { VueperSlides, VueperSlide } from 'vueperslides'
import { Component, Prop, Vue } from 'vue-property-decorator'
import Modal from '@/components/Modal.vue'
import 'vueperslides/dist/vueperslides.css'

interface VueperSlides {
	resumeAutoplay: Function;
}

@Component({
	components: {
		VueperSlides,
		VueperSlide,
		Modal
	}
})
export default class Carousel extends Vue {
	@Prop({ default: () => [{}] }) readonly items!: Array<object>
	@Prop({ default: () => true }) readonly autoplaying!: boolean
	@Prop({ default: () => false }) readonly autoSelected!: boolean

	images: Array<object> = [{}]
	current= ""
	modalImage = false
	pauseOnHover = true

	hideSlide() {
		this.modalImage = false;
		if (this.images.length > 1) ((this.$refs.Carousel as unknown) as VueperSlides).resumeAutoplay()
	}

	zoomSlide(currentSlide: string) {
		this.current = currentSlide
		this.modalImage = true
	}

	created() {
		this.images = this.items
	}
}
</script>

<style lang="scss" scoped>
.zoomButton {
	position: absolute;
	background-color: transparent;
	height: 100%;
	width: 100%;
	border-width: 0;
	z-index: 2;
}

.vueperslides {
	width: 100%;
	height: 100%;
	position: absolute;
	background-color: white;
box-shadow: none;
	::v-deep .vueperslide {
		opacity: 1;
		// border: 1px;
		background-repeat: no-repeat;
		background-size: contain;
		background-position: center;
	}

	::v-deep .vueperslides__arrow {
		z-index: 3;
	}

	::v-deep .vueperslides__inner {
		height: 27vh;
	}

	::v-deep .vueperslides__bullet {
		margin: 1.5em 0.3em;
		z-index: 3;

		.default {
			background-color: rgba(255, 255, 255, 0.5);
			border: none;
			box-shadow: none;
			transition: 0.3s;
			width: 10px;
			height: 10px;
		}
	}

	::v-deep .vueperslides__bullet--active .default {
		background-color: #fff;
	}
}

.modal {
	::v-deep .modal-container {
		width: 90%;
		padding: 10px 10px;
		

		.modal-image {
			width: 100%;
			height: 100%;
			object-fit: contain;
		}
	}
}

@media (min-width: 960px), (orientation: landscape)  {
	.modal {
		::v-deep .modal-container {
			width: 80vh;
			height: 80vh;
		}
	}
}
</style>
